## xen 4.11.4+37-g3263f257ca

=== debian/changelog ===
xen (4.11.4+37-g3263f257ca-1) buster-security; urgency=high

  * Update to new upstream version 4.11.4+37-g3263f257ca, which also contains
    security fixes for the following issues:
    - x86 pv: Crash when handling guest access to MSR_MISC_ENABLE
      XSA-333 CVE-2020-25602
    - race when migrating timers between x86 HVM vCPU-s
      XSA-336 CVE-2020-25604
    - PCI passthrough code reading back hardware registers
      XSA-337 CVE-2020-25595
    - once valid event channels may not turn invalid
      XSA-338 CVE-2020-25597
    - x86 pv guest kernel DoS via SYSENTER
      XSA-339 CVE-2020-25596
    - Missing memory barriers when accessing/allocating an event channel
      XSA-340 CVE-2020-25603
    - out of bounds event channels available to 32-bit x86 domains
      XSA-342 CVE-2020-25600
    - races with evtchn_reset()
      XSA-343 CVE-2020-25599
    - lack of preemption in evtchn_reset() / evtchn_destroy()
      XSA-344 CVE-2020-25601
  * Note that with this update, we will be detaching the Buster updates from
    the Xen version in Debian unstable, which will get a newer Xen version
    RSN.

 -- Hans van Kranenburg <hans@knorrie.org>  Thu, 01 Oct 2020 14:50:58 +0200

xen (4.11.4+24-gddaaccbbab-1~deb10u1) buster-security; urgency=high

  * Rebuild as Buster security update.

 -- Hans van Kranenburg <hans@knorrie.org>  Fri, 10 Jul 2020 18:54:34 +0200
